//
//  ViewController.swift
//  IOS03_相对布局
//
//  Created by lee on 2017/12/23.
//  Copyright © 2017年 物联网入门视频教程-IOS部分. All rights reserved.
//

import UIKit

class ViewController: UIViewController,UITextFieldDelegate {

//    var img: UIImageView!
//    var img2: UIImageView!
//    var txtField: UITextField!
    var imgTop: UIImageView!
    var txtUserName: UITextField!
    var txtPassWord: UITextField!
    var imgUserName: UIImageView!
    var imgPassWord: UIImageView!
    var btnLogIn: UIButton!
    var btnCancel: UIButton!
    var emptyView: UIView!
    var labRegister: UILabel!
    var labQuestion: UILabel!
    override func viewDidLoad() {
        super.viewDidLoad()
        
        imgTop = UIImageView()
        
        imgTop.image = UIImage(named: "touxiang1.png")
        
        imgTop.contentMode = UIViewContentMode.scaleAspectFit
        
        view.addSubview(imgTop)
        
        imgTop.translatesAutoresizingMaskIntoConstraints = false
        
        //item:表示要对哪个控件添加约束
        //第一个attribute:表示要对这个控件的哪个属性添加约束
        //relatedBy:表示这个控件与它的父控件或兄弟控件有什么关系
        //toItem:表示这个控件的父控件或兄弟控件
        //第二个attribute:表示父控件或兄弟控件的什么属性
        //multiplier:表示倍数关系
        //constant:表示偏移量
        
        //指定图片等水平位置
        imgTop.superview?.addConstraint(NSLayoutConstraint(item: imgTop, attribute: .centerX, relatedBy: .equal, toItem: self.view, attribute: .centerX, multiplier: 1.0, constant: 0.0))
        //指定图片等竖直位置
        imgTop.superview?.addConstraint(NSLayoutConstraint(item: imgTop, attribute: .centerY, relatedBy: .equal, toItem: self.view, attribute: .centerY, multiplier: 1.0, constant: -180))
        //指定图片等宽
        view.addConstraint(NSLayoutConstraint(item: imgTop, attribute: .width, relatedBy: .equal, toItem: nil, attribute: .notAnAttribute, multiplier: 0.0, constant: 100))
        //指定图片高
        view.addConstraint(NSLayoutConstraint(item: imgTop, attribute: .height, relatedBy: .equal, toItem: nil, attribute: .notAnAttribute, multiplier: 0.0, constant: 100))
        
        
        
        
        txtUserName = UITextField()
        
        txtUserName.placeholder = "username"
        
        txtUserName.borderStyle = UITextBorderStyle.line
        
        view.addSubview(txtUserName)
        
        txtUserName.translatesAutoresizingMaskIntoConstraints = false
        
        //指定uitextField的竖直位置
        view.addConstraint(NSLayoutConstraint(item: txtUserName, attribute: .top, relatedBy: .equal, toItem: imgTop, attribute: .bottom, multiplier: 1.0, constant: 30))
        //指定uitextfield的水平位置
        view.addConstraint(NSLayoutConstraint(item: txtUserName, attribute: .right, relatedBy: .equal, toItem: imgTop, attribute: .right, multiplier: 1.0, constant: 50))
        
        view.addConstraint(NSLayoutConstraint(item: txtUserName, attribute: .left, relatedBy: .equal, toItem: imgTop, attribute: .left, multiplier: 1.0, constant: -20))
        view.addConstraint(NSLayoutConstraint(item: txtUserName, attribute: .height, relatedBy: .equal, toItem: nil, attribute: .notAnAttribute, multiplier: 0.0, constant: 30))
        
        //第二个uitextfield
        txtPassWord = UITextField()
        
        txtPassWord.placeholder = "password"
        
        txtPassWord.isSecureTextEntry = true
        
        txtPassWord.borderStyle = UITextBorderStyle.line
        
        view.addSubview(txtPassWord)
        
        txtPassWord.translatesAutoresizingMaskIntoConstraints = false
        
        //指定图片等宽度
        view.addConstraint(NSLayoutConstraint(item: txtPassWord, attribute: .left, relatedBy: .equal, toItem: txtUserName, attribute: .left, multiplier: 1.0, constant: 0.0))
        view.addConstraint(NSLayoutConstraint(item: txtPassWord, attribute: .right, relatedBy: .equal, toItem: txtUserName, attribute: .right, multiplier: 1.0, constant: 0.0))
        //指定图片等顶部距离txtusername控件的底部有20px间距
        view.addConstraint(NSLayoutConstraint(item: txtPassWord, attribute: .top, relatedBy: .equal, toItem: txtUserName, attribute: .bottom, multiplier: 1.0, constant: 20))
        view.addConstraint(NSLayoutConstraint(item: txtPassWord, attribute: .height, relatedBy: .equal, toItem: nil, attribute: .notAnAttribute, multiplier: 0.0, constant: 30))
        
        
        
        imgUserName = UIImageView()
        
        imgUserName.image = UIImage(named: "touxiang2.png")
        
        imgUserName.contentMode = UIViewContentMode.scaleAspectFit
        
        view.addSubview(imgUserName)
        
        
        imgUserName.translatesAutoresizingMaskIntoConstraints = false
        
        //底部与兄弟控件的底部对齐
        view.addConstraint(NSLayoutConstraint(item: imgUserName, attribute: .bottom, relatedBy: .equal, toItem: txtUserName, attribute: .bottom, multiplier: 1.0, constant: 0.0))
        //顶部与它的兄弟控件的顶部对齐
        view.addConstraint(NSLayoutConstraint(item: imgUserName, attribute: .top, relatedBy: .equal, toItem: txtUserName, attribute: .top, multiplier: 1.0, constant: 0.0))
        //右部与它的兄弟控件（txtUserName）的左部产生10个单位的间距
        view.addConstraint(NSLayoutConstraint(item: imgUserName, attribute:
            .right, relatedBy: .equal, toItem: txtUserName, attribute: .left, multiplier: 1.0, constant: -10))
        //imgUserName的宽度等于它的兄弟控件的高度
        view.addConstraint(NSLayoutConstraint(item: imgUserName, attribute: .width, relatedBy: .equal, toItem: txtUserName, attribute: .height, multiplier: 1.0, constant: 0.0))
        
        
        
        
        imgPassWord = UIImageView()
        
        imgPassWord.image = UIImage(named: "mima.png")
        
        imgPassWord.contentMode = UIViewContentMode.scaleAspectFit
        
        view.addSubview(imgPassWord)
        
        imgPassWord.translatesAutoresizingMaskIntoConstraints = false
        
        //底部与兄弟控件的底部对齐
        view.addConstraint(NSLayoutConstraint(item: imgPassWord, attribute: .bottom, relatedBy: .equal, toItem: txtPassWord, attribute: .bottom, multiplier: 1.0, constant: 0.0))
        //顶部与它的兄弟控件的顶部对齐
        view.addConstraint(NSLayoutConstraint(item: imgPassWord, attribute: .top, relatedBy: .equal, toItem: txtPassWord, attribute: .top, multiplier: 1.0, constant: 0.0))
        //左部与它的兄弟控件的左部对齐
        view.addConstraint(NSLayoutConstraint(item: imgPassWord, attribute: .left, relatedBy: .equal, toItem: imgUserName, attribute: .left, multiplier: 1.0, constant: 0.0))
        //右部与它的兄弟控件的右部对齐
        view.addConstraint(NSLayoutConstraint(item: imgPassWord, attribute: .right, relatedBy: .equal, toItem: imgUserName, attribute: .right, multiplier: 1.0, constant: 0.0))
        
        
        
        //UIButton
        btnLogIn = UIButton()
        
        btnLogIn.setTitle("登录", for: UIControlState.normal)
        
        btnLogIn.backgroundColor = UIColor.gray
        
        view.addSubview(btnLogIn)
        
        btnLogIn.translatesAutoresizingMaskIntoConstraints = false
        
        //指定控件的顶部与它的兄弟控件的底部产生一个间距
        view.addConstraint(NSLayoutConstraint(item: btnLogIn, attribute: .top, relatedBy: .equal, toItem: txtPassWord, attribute: .bottom, multiplier: 1.0, constant: 30))
        view.addConstraint(NSLayoutConstraint(item: btnLogIn, attribute: .left, relatedBy: .equal, toItem: txtPassWord, attribute: .left, multiplier: 1.0, constant: -10))
        view.addConstraint(NSLayoutConstraint(item: btnLogIn, attribute: .right, relatedBy: .equal, toItem: self.view, attribute: .centerX, multiplier: 1.0, constant: -5))
        view.addConstraint(NSLayoutConstraint(item: btnLogIn, attribute: .height, relatedBy: .equal, toItem: imgPassWord, attribute: .height, multiplier: 1.0, constant: 10))
        
        
        
        
        btnCancel = UIButton()
        
        btnCancel.setTitle("取消", for: UIControlState.normal)
        
        btnCancel.backgroundColor = UIColor.gray
        
        view.addSubview(btnCancel)
        
        btnCancel.translatesAutoresizingMaskIntoConstraints = false
        
        //指定控件的顶部与它的兄弟控件的底部产生一个间距
        view.addConstraint(NSLayoutConstraint(item: btnCancel, attribute: .top, relatedBy: .equal, toItem: txtPassWord, attribute: .bottom, multiplier: 1.0, constant: 30))
        
        view.addConstraint(NSLayoutConstraint(item: btnCancel, attribute: .left, relatedBy: .equal, toItem: self.view, attribute: .centerX, multiplier: 1.0, constant: 5))
        
        view.addConstraint(NSLayoutConstraint(item: btnCancel, attribute: .bottom, relatedBy: .equal, toItem: btnLogIn, attribute: .bottom, multiplier: 1.0, constant: 0.0))
        
        view.addConstraint(NSLayoutConstraint(item: btnCancel, attribute: .width, relatedBy: .equal, toItem: btnLogIn, attribute: .width, multiplier: 1.0, constant: 0.0))
        
        
        
        
        emptyView = UIView()
        emptyView.backgroundColor = UIColor.green
        view.addSubview(emptyView)
        
        emptyView.translatesAutoresizingMaskIntoConstraints = false
        
        
        view.addConstraint(NSLayoutConstraint(item: emptyView, attribute: .centerX, relatedBy: .equal, toItem: self.view, attribute: .centerX, multiplier: 1.0, constant: 0.0))
        view.addConstraint(NSLayoutConstraint(item: emptyView, attribute: .top, relatedBy: .equal, toItem: btnLogIn, attribute: .bottom, multiplier: 1.0, constant: 30))
        view.addConstraint(NSLayoutConstraint(item: emptyView, attribute: .width, relatedBy: .equal, toItem: nil, attribute: .notAnAttribute, multiplier: 0.0, constant: 2.0))
        view.addConstraint(NSLayoutConstraint(item: emptyView, attribute: .height, relatedBy: .equal, toItem: txtPassWord, attribute: .height, multiplier: 1.0, constant: 0.0))
        
        
        
        labRegister = UILabel()
        
        labRegister.text = "注册"
        
        labRegister.font = UIFont.systemFont(ofSize: 20)
        labRegister.textColor = UIColor.green
        
        view.addSubview(labRegister)
        
        labRegister.translatesAutoresizingMaskIntoConstraints = false
        
        view.addConstraint(NSLayoutConstraint(item: labRegister, attribute: .right, relatedBy: .equal, toItem: emptyView, attribute: .left, multiplier: 1.0, constant: -20))
        view.addConstraint(NSLayoutConstraint(item: labRegister, attribute: .top, relatedBy: .equal, toItem: emptyView, attribute: .top, multiplier: 1.0, constant: 5))
        view.addConstraint(NSLayoutConstraint(item: labRegister, attribute: .bottom, relatedBy: .equal, toItem: emptyView, attribute: .bottom, multiplier: 1.0, constant: -5))
        
        
        labQuestion = UILabel()
        
        labQuestion.text = "遇到问题"
        
        labQuestion.textColor = UIColor.green
        
        labQuestion.font = UIFont.systemFont(ofSize: 20)
        
        view.addSubview(labQuestion)
        
        labQuestion.translatesAutoresizingMaskIntoConstraints = false
        
        view.addConstraint(NSLayoutConstraint(item: labQuestion, attribute: .top, relatedBy: .equal, toItem: labRegister, attribute: .top, multiplier: 1.0, constant: 0.0))
        
        view.addConstraint(NSLayoutConstraint(item: labQuestion, attribute: .bottom, relatedBy: .equal, toItem: labRegister, attribute: .bottom, multiplier: 1.0, constant: 0.0))
        
        view.addConstraint(NSLayoutConstraint(item: labQuestion, attribute: .left, relatedBy: .equal, toItem: emptyView, attribute: .right, multiplier: 1.0, constant: 20))
//        img = UIImageView()
//        
//        //指定图片来源
//        img.image = UIImage(named: "flower.png")
//        
//        //设置图片的位置和大小
//        img.frame = CGRect(x: 50, y: 50, width: 100, height: 100)
//        
//        
//        //图片等填充方式
//        img.contentMode = UIViewContentMode.scaleAspectFill
//        img.backgroundColor = UIColor.red
//        
//        view.addSubview(img)
        
        
//        img2 = UIImageView()
//        
//        img2.image = UIImage(named: "bird.png")
//        
//        img2.frame = CGRect(x: 50, y: 200, width: 100, height: 100)
//        
//        img2.contentMode = UIViewContentMode.scaleAspectFill
//        
//        img2.backgroundColor = UIColor.green
//        
//        view.addSubview(img2)
        
//        txtField = UITextField()
//        
//        txtField.frame = CGRect(x: 50, y: 200, width: 200, height: 30)
//        
//        //水印文字
//        txtField.placeholder = "username"
//        
//        //设置边框
//        txtField.borderStyle = UITextBorderStyle.line
//        
//        //安全输入
//        txtField.isSecureTextEntry = true
//        
//        
//        //背景颜色
//        txtField.backgroundColor = UIColor.green
//        
//        txtField.delegate = self
//        
//        view.addSubview(txtField)
    }

//    override func didReceiveMemoryWarning() {
//        super.didReceiveMemoryWarning()
//        // Dispose of any resources that can be recreated.
//    }
//    
//    func textFieldShouldReturn(_ textField: UITextField) -> Bool {
//        
//        textField.resignFirstResponder()
//        return true
//    }
//    
//    override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
//        
//        view.endEditing(true)
//    }


}

